[General]
SyntaxVersion=2
MacroID=abf77a8b-f1a9-44a2-a968-2b81a2b7af6a
[Comment]

[Script]
// POST
Function HttpPost(posturl,params)
    Dim oauth_http
    Set oauth_http =  CreateObject("Msxml2.ServerXMLHTTP")
    oauth_http.SetOption 2, 13056
    oauth_http.Open "POST", posturl, False, "", ""
    oauth_http.SetRequestHeader "Content-Type", "application/x-www-form-urlencoded"
    oauth_http.Send (params)
    If oauth_http.Status = "200" Then
        HttpPost = oauth_http.responseText
    Else
        HttpPost = ""
    End If
    Set oauth_http=nothing 
End Function
// BASE64 
Function Base64Encode(inData)
    Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
    Dim cOut, sOut, I
    For I = 1 To Len(inData) Step 3
        Dim nGroup, pOut, sGroup
        nGroup = &H10000 * Asc(Mid(inData, I, 1)) + _
      &H100 * MyASC(Mid(inData, I + 1, 1)) + MyASC(Mid(inData, I + 2, 1))
        nGroup = Oct(nGroup)
        nGroup = String(8 - Len(nGroup), "0") & nGroup
        pOut = Mid(Base64, CLng("&o" & Mid(nGroup, 1, 2)) + 1, 1) + _
      Mid(Base64, CLng("&o" & Mid(nGroup, 3, 2)) + 1, 1) + _
      Mid(Base64, CLng("&o" & Mid(nGroup, 5, 2)) + 1, 1) + _
      Mid(Base64, CLng("&o" & Mid(nGroup, 7, 2)) + 1, 1)
        sOut = sOut + pOut
    Next
    Select Case Len(inData) Mod 3
    Case 1: '8 bit final
        sOut = Left(sOut, Len(sOut) - 2) + "=="
    Case 2: '16 bit final
        sOut = Left(sOut, Len(sOut) - 1) + "="
    End Select
    Base64Encode = sOut
End Function
Function MyASC(OneChar)
    If OneChar = "" Then MyASC = 0 Else MyASC = Asc(OneChar)
End Function
// BASE64 
Function Base64Decode(ByVal base64String)
    Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
    Dim dataLength, sOut, groupBegin
    base64String = Replace(base64String, vbCrLf, "")
    base64String = Replace(base64String, vbTab, "")
    base64String = Replace(base64String, " ", "")
    dataLength = Len(base64String)
    If dataLength Mod 4 <> 0 Then 
        Base64Decode = base64String
        Exit Function
    End If
    For groupBegin = 1 To dataLength Step 4
        Dim numDataBytes, CharCounter, thisChar, thisData, nGroup, pOut
        numDataBytes = 3
        nGroup = 0
        For CharCounter = 0 To 3
            thisChar = Mid(base64String, groupBegin + CharCounter, 1)
            If thisChar = "=" Then
                numDataBytes = numDataBytes - 1
                thisData = 0
            Else
                thisData = InStr(1, Base64, thisChar, vbBinaryCompare) - 1
            End If
            If thisData = -1 Then
                Err.Raise 2, "Base64Decode", "Bad character In Base64 string."
                Exit Function
            End If
            nGroup = 64 * nGroup + thisData
        Next
        nGroup = Hex(nGroup)
        nGroup = String(6 - Len(nGroup), "0") & nGroup
        pOut = Chr(CByte("&H" & Mid(nGroup, 1, 2))) + _
      Chr(CByte("&H" & Mid(nGroup, 3, 2))) + _
      Chr(CByte("&H" & Mid(nGroup, 5, 2)))
        sOut = sOut & Left(pOut, numDataBytes)
    Next
    Base64Decode = sOut
End Function
Function BytesToString(bytIn)
    Dim i
    Dim strRet
    strRet = ""
    For i = 0 To UBound(bytIn)
        strRet = strRet & Chrw(bytIn(i))
    Next
    BytesToString = strRet
End Function
Function H2D(hstrIn)
    Dim D,H,i,Ia,iSign
    D = 0
    If left(hstrIn,1) = "-" Then
        hstrIn = Mid(hstrIn, 2)
        iSign = true
    Else 
        iSign = False
    End If
    H = UCase(hstrIn)
    For i = 1 To Len(H)
        Ia = Asc(Mid(H, i, 1)) - 48
        If Ia > 9 Then Ia = Ia - 7
        D = D * 16 + Ia
    Next
    If iSign Then 
        H2D = CInt(("-" & D))
    Else 
        H2D =  D
    End If
End Function